<?php

 
	function queyGpsRouteListByimei( $imei, $start_time, $end_time ){
		$dsnV2 = C('DB_DSN_V2');
		//地图无分页,占用内存大
		if(!$start_time){
			$start_time=date('Y-m-d').' 00:00:00';
		}
		if(!$end_time){
			$end_time=date('Y-m-d').' 23:59:59';
		}
		ini_set('memory_limit', '512M');
		
		$startTime = strtotime($start_time);
		$endTime = strtotime($end_time);
		
		$device_number = $imei;
		
		$where = array(
			'DeviceNumber' => trim($device_number),
			'Timestamp' => array('between', array($startTime, $endTime)),
		);
		
		
		$option['table_name'] = 'wxt_route_gps';
		
		$model = new \OtsModel($option['table_name']);
		if(!$model){
			$this->errmsg = 'failed to init otsmodel ' . $tableName;
			return false;	
		}
		
		$option['pagesize'] = 4000;
		$option['sort'] = 'desc';
		
		
		$data = $model->limit($option['pagesize'])->order($option['sort'])->where($where)->select();
		
		
		foreach($data as &$val){
			$val['OnlineTime']=date('Y-m-d H:i:s',$val['Timestamp']);
		}
		
		return $data;
		
	}
	
 
	function analyzeRouteInfoWayzBatch( $list, $route_type ){
		if(!$list){
		    return array();
		}
		$macLength=0;
		foreach($list as $item){
		    if(isset($item['WifiMacs']) && $item['WifiMacs'] !=''){
		        $macLength++;
		    }
		}
		$lngLatAlter = new \Jms\Algo\Geometry();
		$arr= [];
		        
		$preTime=0;
		$filter=0;//默认不过滤
		$wifiPreTime=0;
		$wifiFilter=0;//默认不过滤
		
		$batch_wifi=array();
		foreach($list  as $k=> $v){
		        if($filter>0){//gps点过多时间也过滤部分
		            $interval=abs($v['Timestamp']-$preTime);
		            if( $interval < $filter){
		                continue;
		            }
		        }
		        if(isset($v['WifiMacs']) && $v['WifiMacs'] !=''){
		            $wifiInterval=abs($v['Timestamp']-$wifiPreTime);
		            if( $wifiInterval < $wifiFilter){
		                continue;
		            }
		            if($route_type=='GPS'){
		                continue;
		            }
		            $batch_wifi[$k]=$v;
		            if(count($batch_wifi)==16 || $k==($count-1)){
		                $wifiRes =requestWifiLBS_wayz_batch($batch_wifi);
		                foreach($wifiRes as $key=>$value){
		                    if($value['success']){
		                        if($value['data']['lon'] == '' || is_null($value['data']['lat'])){
		                            continue;
		                        }
		                        $list[$key]['Latitude'] = $value['data']['lat'];
		                        $list[$key]['Longitude'] = $value['data']['lon'];
		                        $list[$key]['SignalType'] = 'WiFi';
		                        // $list[$key]['WifiAddress'] = $value['data']['address'];
		                        if(isset($value['data']['address'])){
		                            $list[$key]['WifiAddress'] = $value['data']['address'];
		                        }
		                        $arr[$key]=$list[$key];
		                        //array_push($arr, $list[$k]);
		                    }else{
										continue;
									 }
		                    
		                }
		                $batch_wifi=array();
		            }
		        
		            $wifiPreTime=$v['Timestamp'];
		        }else{
		            if($route_type=='WiFi'){
		                continue;
		            }
						if($v['Altitude']=='0.003' || $v['Altitude']=='3'){
		               continue;
		            }
		            if( !isset($v['Latitude']) ||  !isset($v['Longitude']) || $v['Latitude']<0.065 || $v['Longitude']<0.065){
		                continue;
		            }
						$latLng = $lngLatAlter->convertBd09ToGcj02($v['Latitude'], $v['Longitude']);
						$list[$k]['Latitude'] = $latLng['lat'];
						$list[$k]['Longitude'] = $latLng['lng'];
		            $list[$k]['SignalType'] = 'GPS';
		            $arr[$k]=$list[$k];
		            //array_push($arr, $list[$k]);
		        }
		        $preTime=$v['Timestamp'];
		}
		//防止最后剩余wifi点未更新
		if($batch_wifi){
		    $wifiRes =requestWifiLBS_wayz_batch($batch_wifi);
		    foreach($wifiRes as $key=>$value){
		            if($value['success']){
		                if($value['data']['lon'] == '' || is_null($value['data']['lat'])){
		                    continue;
		                }
		                $list[$key]['Latitude'] = $value['data']['lat'];
		                $list[$key]['Longitude'] = $value['data']['lon'];
		                $list[$key]['SignalType'] = 'WiFi';
		                // $list[$key]['WifiAddress'] = $value['data']['address'];
		                if(isset($value['data']['address'])){
		                    $list[$key]['WifiAddress'] = $value['data']['address'];
		                }
		                $arr[$key]=$list[$key];
		                //array_push($arr, $list[$k]);
		            }else{
		                continue;
		            }
		                    
		    }
		    $batch_wifi=array();
		}
		ksort($arr);
		$response_data=[];
		foreach($arr as $item){
		    array_push($response_data, $item);
		}
		return $response_data;
	}
	
 
	function bmapFilterOutliers( $rows ){
		if(!$rows){
		    return array();
		}
		$response_data=[];
		$point1=[];
		$speedArr=[];
		$timestamp=0;
		$geometry = new \Jms\Algo\Geometry();
		for($i=0;$i<count($rows);$i++){
		    if($i==0){
		        //当前最新的一个定位保留
		        $timestamp=$rows[$i]['Timestamp'];
		        array_push($response_data, $rows[$i]);
		        $point1=['lng'=>$rows[$i]['Longitude'],'lat'=>$rows[$i]['Latitude']];
		        continue;
		    }
		    $point2=['lng'=>$rows[$i]['Longitude'],'lat'=>$rows[$i]['Latitude']];
		     $distance = $geometry->distanceBetween2BdPoints($point1,$point2);
		    $time=($timestamp-$rows[$i]['Timestamp'])/3600;//单位h
		    $speed=$distance/$time;//计算速度  超过130的默认为异常点
		    $speedArr[]=$speed;
		    if($rows[$i]['SignalType']=='WiFi'){
		        $length=count($speedArr);
		        if($length>=5){
		            $filterSpeed=($speedArr[$length-1]+$speedArr[$length-2]+$speedArr[$length-3]+$speedArr[$length-4]+$speedArr[$length-5])/5*1.5;//超过平均速度 1.5倍
		        }else{
		            $filterSpeed=50;
		        }
				   if($filterSpeed<10){
		          $filterSpeed=10;
		        }
		        if($speed<$filterSpeed){
		            $timestamp=$rows[$i]['Timestamp'];
		            $point1=$point2;
		            array_push($response_data, $rows[$i]);
		        }else{
		            array_pop($speedArr);//去除无效速度
		        }
		    }else{
		        $timestamp=$rows[$i]['Timestamp'];
		        $point1=$point2;
		        //只有wifi点需要过滤 gps点不过滤
		        array_push($response_data, $rows[$i]);
		    }
		    
		}
		return $response_data;
		return bmapReverseFilterOutliers($response_data);
	}
	
 
	function bmapReverseFilterOutliers( $rows ){
		if(!$rows){
		    return array();
		}
		$response_data=[];
		$point1=[];
		$speedArr=[];
		$timestamp=0;
		$geometry = new \Jms\Algo\Geometry();
		for($i=count($rows)-1;$i>=0;$i--){
		    if($i==count($rows)-1){
		        //当前最新的一个定位保留
		        array_push($response_data, $rows[$i]);
		        $timestamp=$rows[$i]['Timestamp'];
		        $point1=['lng'=>$rows[$i]['Longitude'],'lat'=>$rows[$i]['Latitude']];
		        continue;
		    }
		    $point2=['lng'=>$rows[$i]['Longitude'],'lat'=>$rows[$i]['Latitude']];
		    $distance = $geometry->distanceBetween2BdPoints($point1,$point2);
		    $time=($rows[$i]['Timestamp']-$timestamp)/3600;//单位h
		    $speed=$distance/$time;//计算速度  超过130的默认为异常点
		    $speedArr[]=$speed;
		    if($rows[$i]['SignalType']=='WiFi'){
		        $length=count($speedArr);
		        if($length>=5){
		            $filterSpeed=($speedArr[$length-1]+$speedArr[$length-2]+$speedArr[$length-3]+$speedArr[$length-4]+$speedArr[$length-5])/5*1.5;//超过平均速度 1.5倍
		        }else{
		            $filterSpeed=50;
		        }
		        // test_log('filt_map','['.$rows[$i]['PassTime'].'] filterSpeed: '. $filterSpeed.'speed: '. $speed.' time: '. $time);
				   if($filterSpeed<10){
		          $filterSpeed=10;
		        }
		        if($speed<$filterSpeed){
		            $point1=$point2;
		             $timestamp=$rows[$i]['Timestamp'];
		            array_push($response_data, $rows[$i]);
		        }else{
		            array_pop($speedArr);//去除无效速度
		        }
		    }else{
		        $point1=$point2;
		         $timestamp=$rows[$i]['Timestamp'];
		        //只有wifi点需要过滤 gps点不过滤
		        array_push($response_data, $rows[$i]);
		    }
		    
		}
		$res_data=[];
		for($i=0;$i<count($response_data)-1;$i++){
		    array_push($res_data, $response_data[$i]);
		}
		return $res_data;
	}
	
 
	function requestWifiLBS_wayz_batch( $routeArr ){
		if(!$routeArr){
		            return array(
		                'success' => false,
		                'msg' => '空数据'
		            );
		        }
		
		        //当前毫秒时间戳
		        list($msec, $sec) = explode(' ', microtime());
		        $msectime = (float)sprintf('%.0f', (floatval($msec) + floatval($sec)) * 1000);
		        //鉴权方式 采用 access_key 的方式，在 URL 的 Query Param 中添加 access_key。
		        $access_key = 'VOiuxRnGhlJsAzVzhaU2Hen24zvwuWck';
		        $post_data=array();
		        $batch_keys=array();
		        $isFilter=true;//
		        $filterSignal=85;//过滤信号强度
		        $filterTotal=5;//wifi个数大于次数才开始过滤
		
		        foreach($routeArr as $k=>$routeInfo){
		            $asset = array(
		                "id"=>date('YmdHis'),
		                "manufacturer"=>"hzrl",
		                "model"=>"校园卡",
		                "imeiMd5"=> md5($routeInfo['DeviceNumber']),
		                "macAddress"=>$routeInfo['DeviceNumber'],
		                "serialNumber"=> "",
		                "uniqueId"=> $routeInfo['DeviceNumber'],
		                /*"os"=>array(
		                    "type"=> "",
		                    "version"=> ""
		                )*/
		            );
		            //处理WiFi信息
		            $WifiMacs = $routeInfo['WifiMacs'];
		            $WifiMacs = explode('|',$WifiMacs);
		            $wifis = [];
		            $countWifi=count($WifiMacs);
		
		            
		            $total=0;//wifimacs上报 默认按强度排序 可直接计算不过滤前$filterTotal个
		            foreach($WifiMacs as $v){
		                $total++;
		                $w = explode(',',$v);
		                $wifi = array(
		                    "timestamp"=> intval($msectime),
		                    "signalStrength"=> abs($w[1]),
		                    "macAddress"=> $w[0],
		                );
		                //判断是否需要过滤
		                if( $isFilter &&  ($total>$filterTotal) &&  ($wifi['signalStrength'] >  $filterSignal )){
		                    continue;
		                }
		                array_push($wifis,$wifi);
		            }
						 if(count($wifis)<=3){
		                continue;
		            }
		            $data = array(
		                'timestamp'=>intval($msectime),
		                'id'=>date('YmdHis'),
		                'asset'=>$asset,
		                'location'=>array(
		                    "wifis"=>$wifis
		                )
		            );
		            //$post_data[$k]=$data;
		            array_push($post_data,$data);
		            array_push($batch_keys,$k);
		        }
		
		        $url = "https://api.newayz.com/location/hub/v1/track_points?batch=true&access_key=".$access_key."&field_masks=location.position,location.address,location.place";
		        //var_dump($url);
		        //发送数据data
		        
		        $post_data = json_encode( $post_data );
		
		        $curl = curl_init();
		        curl_setopt($curl, CURLOPT_URL, $url);
		        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
		        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
		        curl_setopt($curl, CURLOPT_POST, 1);
		        curl_setopt($curl, CURLOPT_POSTFIELDS, $post_data);
		        curl_setopt($curl, CURLOPT_HEADER, 0);
		        curl_setopt($curl, CURLOPT_HTTPHEADER,
		                    array(
		                        'Content-Type: application/json; charset=utf-8',
		                        'Content-Length:' . strlen($post_data)
		                    )
		                   );
		        // curl_setopt($curl, CURLOPT_HTTPHEADER, array('Accept-Encoding: gzip, deflate'));
		        // curl_setopt($curl, CURLOPT_ENCODING, "gzip");
		        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		        $response = curl_exec($curl);
		        $errorno = curl_errno($curl);
		        if ($errorno) {
		            return array('success' => false, 'data' => $errorno);
		        }
		        curl_close($curl);
		        if(count($batch_keys)==1){
		            $response = [json_decode($response, true)];
		        }else{
		            $response = json_decode($response, true);
		        }
		        
		        $response_data=array();
		        foreach($response as $key=>$value){
		            $response_key=$batch_keys[$key];
		
		            $item=[];
		            // var_dump($value);
		            if(!isset($value['location'])  ){
		                $item=array(
		                    'success' => false,
		                    'msg' => '定位信息解析失败'
		                );
		            }else{
		                $location = $value['location'];
		                if(!isset($location['position']) ){
		                    $item=array(
		                        'success' => false,
		                        'msg' =>'定位信息解析失败'
		                    );
		                }else{
		                    $position = $location['position'];
		                    $point = $position['point'];
		    
		                  
		                    $address = array(
		                        'lon' => $point['longitude'],
		                        'lat' => $point['latitude'],
		                        // 'address' => $location['address']['name']
		                    );
		                    if(isset($location['address']['name'])){
		                        $address['address']=$location['address']['name'];
		                    }
		                    
		                    $item=array(
		                        'success' => true,
		                        'data' => $address
		                    );
		                }
		
		            }
		            
		            $response_data[$response_key]=$item;
		        }
		        
		        return $response_data;
	}
	
 
	function requestWifiLBS_wayz( $routeInfo ){
		if(!$routeInfo){
			return array(
				'success' => false,
				'msg' => '空数据'
			);
		}
		if(!isset( $routeInfo['WifiMacs']) ){
			return array(
				'success' => false,
				'msg' => '无wifi信息'
			);
		}
		//当前毫秒时间戳
		list($msec, $sec) = explode(' ', microtime());
		$msectime = (float)sprintf('%.0f', (floatval($msec) + floatval($sec)) * 1000);
		//鉴权方式 采用 access_key 的方式，在 URL 的 Query Param 中添加 access_key。
		$access_key = 'VOiuxRnGhlJsAzVzhaU2Hen24zvwuWck';
		//处理WiFi信息
		$WifiMacs = $routeInfo['WifiMacs'];
		$WifiMacs = explode('|',$WifiMacs);
		$wifis = [];
		foreach($WifiMacs as $v){
			$w = explode(',',$v);
			$wifi = array(
				"timestamp"=> intval($msectime),
				"signalStrength"=> abs($w[1]),
				"macAddress"=> $w[0],
				//"ssid"=> "AiMap",
				//"frequency"=> 0,
				//"channel"=> 0,
				//"connected"=> true
			);
			array_push($wifis,$wifi);
		}
		$asset = array(
			"id"=>date('YmdHis'),
			"manufacturer"=>"hzrl",
			"model"=>"校园卡",
			"imeiMd5"=> md5($routeInfo['DeviceNumber']),
			"macAddress"=>$routeInfo['DeviceNumber'],
			"serialNumber"=> "",
			"uniqueId"=> $routeInfo['DeviceNumber'],
			/*"os"=>array(
				"type"=> "",
				"version"=> ""
			)*/
		);
		$url = "https://api.newayz.com/location/hub/v1/track_points?access_key=".$access_key."&field_masks=location.position,location.address,location.place";
		//var_dump($url);
		//发送数据data
		$data = array(
			'timestamp'=>intval($msectime),
			'id'=>date('YmdHis'),
			'asset'=>$asset,
			'location'=>array(
				"wifis"=>$wifis
			)
		);
		$data = json_encode( $data );
		debug_log('wayz_wifi_data',$routeInfo['DeviceNumber']."发送数据：".$data);
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
		curl_setopt($curl, CURLOPT_HEADER, 0);
		curl_setopt($curl, CURLOPT_HTTPHEADER,
					array(
						'Content-Type: application/json; charset=utf-8',
						'Content-Length:' . strlen($data)
					)
				   );
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		$response = curl_exec($curl);
		$errorno = curl_errno($curl);
		if ($errorno) {
			return array('success' => false, 'data' => $errorno);
		}
		debug_log('wayz_wifi_res',$routeInfo['DeviceNumber']."返回结果".$response);
		curl_close($curl);
		$response = json_decode($response, true);
		//echo '-------way ---------';
		//var_dump($response);
		//var_dump($response);
		/*if($response['info'] != 'OK' || count($response['result']) <2 ){
				return array(
					'success' => false,
					'msg' => $response['info']
				);
			}*/
		$location = $response['location'];
		$position = $location['position'];
		$point = $position['point'];
		$geometry = new \Jms\Algo\Geometry();
		$lngLat = $geometry->convertGcj02ToBd09($point['latitude'],$point['longitude']);
		$response = array(
			'lon' => $lngLat['lng'],
			'lat' => $lngLat['lat'],
			'address' => $location['address']['name']
		);
		debug_log('wayz_wifi_res',$routeInfo['DeviceNumber']."转换坐标后：".json_encode($response,JSON_UNESCAPED_UNICODE));
		
		//var_dump($response);
		//echo '--------way end---------';
		return array(
			'success' => true,
			'data' => $response
		);
		
	}
	
 
	function requestWifiLBS_gaode( $routeInfo ){
		if(!$routeInfo){
			return array(
				'success' => false,
				'msg' => '空数据'
			);
		}
		if(!isset( $routeInfo['WifiMacs']) ){
			return array(
				'success' => false,
				'msg' => '无wifi信息'
			);
		}
		
		$WifiMacs = $routeInfo['WifiMacs'];
		$userKey = '';
		if(!$userKey){
			$userKey = 'f107b0b3a513e6e37c6fb0424bed6633';
		}
		
		//$url = 'http://api.cellocation.com:81/loc/?wl='  . $WifiMacs .'&output=json&coord=gcj02';
		$url = 'http://apilocate.amap.com/position?accesstype=1&imei=' . $routeInfo['DeviceNumber'] . '&macs=' . $WifiMacs . '&key=' . $userKey;
		$curl = curl_init($url);
		
		curl_setopt($curl, CURLOPT_TIMEOUT, 3);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		$response = curl_exec($curl);
		
		if (curl_errno($curl)) {
			$errmsg = curl_error($curl);
			curl_close($curl);
			return array(
				'success' => false,
				'msg' => $errmsg
			);
		}
		
		curl_close($curl);
		$response = json_decode($response, true);
		
		if($response['info'] != 'OK' || count($response['result']) <2 ){
			return array(
				'success' => false,
				'msg' => $response['info']
			);
		}
		
		$result = $response['result'];
		$location = $response['result']['location'];
		$location = explode(',', $location);
		$geometry = new \Jms\Algo\Geometry();
		$lngLat = $geometry->convertGcj02ToBd09($location[1],$location[0]);
		$response = array(
			'lon' => $lngLat['lng'],
			'lat' => $lngLat['lat'],
			'address' => $result['desc']
		);
		
		
		return array(
			'success' => true,
			'data' => $response
		);
		
	}
	
 
	function requestWifiLBS( $routeInfo ){
		if(C('IS_USE_WIFI_WAYZ_API')){
			return requestWifiLBS_wayz($routeInfo);
		}
		if(!$routeInfo){
			return array(
				'success' => false,
				'msg' => '空数据'
			);
		}
		if(!isset( $routeInfo['WifiMacs']) ){
			return array(
				'success' => false,
				'msg' => '无wifi信息'
			);
		}
		
		$WifiMacs = $routeInfo['WifiMacs'];
		$userKey = '';
		if(!$userKey){
			$userKey = 'f107b0b3a513e6e37c6fb0424bed6633';
		}
		//$url = 'http://api.cellocation.com:81/loc/?wl='  . $WifiMacs .'&output=json&coord=gcj02';
		$url = 'http://apilocate.amap.com/position?accesstype=1&imei=' . $routeInfo['DeviceNumber'] . '&macs=' . $WifiMacs . '&key=' . $userKey;
		$curl = curl_init($url);
		
		curl_setopt($curl, CURLOPT_TIMEOUT, 3);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		$response = curl_exec($curl);
		
		if (curl_errno($curl)) {
			$errmsg = curl_error($curl);
			curl_close($curl);
			return array(
				'success' => false,
				'msg' => $errmsg
			);
		}
		
		curl_close($curl);
		$response = json_decode($response, true);
		
		if($response['info'] != 'OK' || count($response['result']) <2 ){
			return array(
				'success' => false,
				'msg' => $response['info']
			);
		}
		
		$result = $response['result'];
		$location = $response['result']['location'];
		$location = explode(',', $location);
		$geometry = new \Jms\Algo\Geometry();
		$lngLat = $geometry->convertGcj02ToBd09($location[1],$location[0]);
		$response = array(
			'lon' => $lngLat['lng'],
			'lat' => $lngLat['lat'],
			'address' => $result['desc']
		);
		
		return array(
			'success' => true,
			'data' => $response
		);
		
	}
	
 
	function requestWifiLBS_gaode_batch( $routeArr ){
		
		if(!$routeArr){
			return array(
				'success' => false,
				'msg' => '空数据'
			);
		}
		$mh = curl_multi_init(); 
		$curlArray = array();
		$t1=microtime(true);
		
		foreach($routeArr as $key=>$routeInfo){
			if(!isset( $routeInfo['WifiMacs'])){
				continue;
			}
		
		
			$WifiMacs = $routeInfo['WifiMacs'];
			$userKey = 'f107b0b3a513e6e37c6fb0424bed6633';
		
			$ch = curl_init();
			$url = 'http://apilocate.amap.com/position?accesstype=1&imei=' . $routeInfo['DeviceNumber'] . '&macs=' . $WifiMacs . '&key=' . $userKey;
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_TIMEOUT, 3);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_multi_add_handle($mh,  $ch); 
			$curlArray[$key] = $ch;
		
		
		}
		// echo count($curlArray);
		//debug_log('gaode_wifi_lbs','count:--'. (count($curlArray)));
		$running = NULL; 
		do { 
			// usleep(10000); 
			curl_multi_exec($mh,$running); 
		} while($running > 0); 
		$response_data=array();
		$success=0;
		$fail=0;
		foreach($curlArray as $key => $info) { 
			// $res[$key] = curl_multi_getcontent($curlArray[$key]); 
			$result = curl_multi_getcontent($curlArray[$key]); 
			$response = json_decode($result,true);
		
			if($response['info'] != 'OK' || count($response['result']) < 2 ){
				$fail++;
				$item=array(
					'success' => false,
					'msg' => '定位信息解析失败'
				);
			}else{
				$success++;
				$result = $response['result'];
				$location = $result['location'];
				$location = explode(',', $location);
				$address = array(
					'lon' => $location[0],
					'lat' => $location[1],
					'address' => $result['desc']
				);
				$item=array(
					'success' => true,
					'data' => $address
				);
		
			}
			$response_data[$key]=$item; 
		
		} 
		debug_log('gaode_wifi_lbs','result:---success:--'.$success.'--fail:--'. $fail);
		foreach($curlArray as $key => $info){ 
			curl_multi_remove_handle($mh, $curlArray[$key]); 
		} 
		curl_multi_close($mh);  
		$t3=microtime(true);
		debug_log('gaode_wifi_lbs','t3:---'. ($t3-$t1));
		//  echo 't3:---'. ($t3-$t2).PHP_EOL;
		return $response_data;
		
	}
	
 
	function analyzeRouteInfoGaodeBatch( $list, $route_type = All ){
		if(!$list){
			return array();
		}
		$macLength=0;
		foreach($list as $item){
			if(isset($item['WifiMacs']) && $item['WifiMacs'] !=''){
				$macLength++;
			}
		}
		$lngLatAlter = new \Jms\Algo\Geometry();
		$arr= [];
		
		$preTime=0;
		$filter=0;//默认不过滤
		
		$wifiPreTime=0;
		$wifiFilter=0;//默认不过滤
		$count=count($list);
		$batch_wifi=array();
		foreach($list  as $k=> $v){
			if($filter>0){//gps点过多时间也过滤部分
				$interval=abs($v['Timestamp']-$preTime);
				if( $interval < $filter){
					continue;
				}
			}
			if(isset($v['WifiMacs']) && $v['WifiMacs'] !=''){
				$wifiInterval=abs($v['Timestamp']-$wifiPreTime);
				if( $wifiInterval < $wifiFilter){
					continue;
				}
				if($route_type=='GPS'){
					continue;
				}
				$batch_wifi[$k]=$v;
				if(count($batch_wifi)==8|| $k==($count-1)){
					$wifiRes =requestWifiLBS_gaode_batch($batch_wifi);
					foreach($wifiRes as $key=>$value){
						if($value['success']){
							if($value['data']['lon'] == '' || is_null($value['data']['lat'])){
								continue;
							}
							$list[$key]['Latitude'] = $value['data']['lat'];
							$list[$key]['Longitude'] = $value['data']['lon'];
							$list[$key]['SignalType'] = 'WiFi';
							$list[$key]['WifiAddress'] = $value['data']['address'];
							$arr[$key]=$list[$key];
							//array_push($arr, $list[$k]);
						}else{
							continue;
						}
		
					}
					$batch_wifi=array();
				}
		
				$wifiPreTime=$v['Timestamp'];
			}else{
				if($route_type=='WiFi'){
					continue;
				}
				if($v['Altitude']=='0.003' || $v['Altitude']=='3'){
		         continue;
		      }
				if( !isset($v['Latitude']) ||  !isset($v['Longitude']) || $v['Latitude']<0.065 || $v['Longitude']<0.065){
					continue;
				}
				$latLng = $lngLatAlter->convertBd09ToGcj02($v['Latitude'], $v['Longitude']);
				$list[$k]['Latitude'] = $latLng['lat'];
				$list[$k]['Longitude'] = $latLng['lng'];
				$list[$k]['SignalType'] = 'GPS';
				$arr[$k]=$list[$k];
				//array_push($arr, $list[$k]);
			}
			$preTime=$v['Timestamp'];
		}
		//防止最后剩余wifi点未更新
		if($batch_wifi){
		    $wifiRes =requestWifiLBS_gaode_batch($batch_wifi);
		    foreach($wifiRes as $key=>$value){
		       if($value['success']){
		          if($value['data']['lon'] == '' || is_null($value['data']['lat'])){
		            continue;
		          }
		          $list[$key]['Latitude'] = $value['data']['lat'];
		          $list[$key]['Longitude'] = $value['data']['lon'];
		          $list[$key]['SignalType'] = 'WiFi';
		          $list[$key]['WifiAddress'] = $value['data']['address'];
		          $arr[$key]=$list[$key];
		          //array_push($arr, $list[$k]);
		       }else{
		         continue;
		       }
		                            
		   }
		   $batch_wifi=array();
		}
		$response_data=[];
		ksort($arr);
		foreach($arr as $key=>$item){
			array_push($response_data, $item);
		}
		return $response_data;
	}
	
 
	function pb_abs_url( $url ){
		if(strpos($url,'http://') === 0)
			return $url;
		if(strpos($url,'https://') === 0)
			return $url;
		return 'http://'.$_SERVER['HTTP_HOST'] . U($url);
	}
	
 
	function hex2str( $hex ){
		$string=""; 
		for($i=0;$i<strlen($hex)-1;$i+=2)
			$string.=chr(hexdec($hex[$i].$hex[$i+1]));
		return  $string;
	}
	
 
	function str2hex( $string ){
		$hex="";
		for($i=0;$i<strlen($string);$i++)
			$hex.=dechex(ord($string[$i]));
		$hex=strtoupper($hex);
		return $hex;
	}
	
 
	function wx_token_cache( $appid, $access_token, $expire_time ){
		$key = 'access_token_'.$appid;
		if(!$expire_time || $expire_time < 0)
			$expire_time = 3600;
		if($access_token){
			S($key,$access_token,$expire_time);
		}
		else{
			return S($key);
		}
	}
	
 
	function create_log( $message, $filename = 'error_log' ){
		//要创建的多级目录
		if(defined('SOLUTION_LOG_PATH')){
			$log_dir = SOLUTION_LOG_PATH .'/xskq/'.date('Y-m-d').'/';
		}else{
			$log_dir = './log/xskq/'.date('Y-m-d').'/';
		}
		//判断目录存在否，不存在则创建目录
		if (!is_dir($log_dir)){  
			//第三个参数是“true”表示能创建多级目录
			$res=mkdir($log_dir,0777,true); 
			exec("chmod -R 777 $log_dir ");
			if (!$res){
				$content = "目录 ". $log_dir." 创建失败";
				if(APP_DEBUG){
					echo $content;
				}
				return array('success'=>false,'message'=>$content);
			}
		}
		$file_path  = $log_dir .$filename. '.log';//要写入文件的文件名（可以是任意文件名），如果文件不存在，将会创建一个
		$content = '['.date('Y-m-d H:i:s') .'] ' .json_encode($message,JSON_UNESCAPED_UNICODE) . PHP_EOL; 
		if(APP_DEBUG){
			echo $content;
		}		
		if(!file_put_contents($file_path, $content,FILE_APPEND)){// 这个函数支持版本(PHP 5) 
			$content = "日志写入失败".PHP_EOL;
			if(APP_DEBUG){
				echo $content;
			}
			return array('success'=>false,'message'=>$content);	
		}
		return array('success'=>true,'message'=>'add log success');
	}
	

